﻿using System;
using System.Reflection;
using ES.Infrastructure35.Reflection_;

namespace ES.Infrastructure35.ComponentModel_.DataAnnotations_
{
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = false, Inherited = false)]
    public class CustomCompareAttribute : CustomValidationBaseAttribute
    {
        private string m_ComparePropertyName = null;
        public string ComparePropertyName { get { return m_ComparePropertyName; } }

        public CustomCompareAttribute(string compareProeprtyName)
        {
            m_ComparePropertyName = compareProeprtyName;
        }

        public override string FormatErrorMessage(string displayName)
        {
            return string.Format(ErrorMessage, displayName, ComparePropertyName);
        }

        protected override bool IsValid(object value)
        {
            PropertyInfo compareProperty = Model.GetType().GetProperty(m_ComparePropertyName);
            if (compareProperty == null)
                return false;

            var compareValue = compareProperty.FastGetValue(Model);
            return compareValue == value;
        }
    }
}
