﻿using System;
using System.Text.RegularExpressions;

namespace ES.Infrastructure35.ComponentModel_.DataAnnotations_
{
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = false, Inherited = false)]
    public class CustomRegularAttribute : CustomValidationBaseAttribute
    {
        private string m_Pattern = null;
        public string Pattern { get { return m_Pattern; } }

        public CustomRegularAttribute(string pattern)
        {
            m_Pattern = pattern;
        }

        protected override bool IsValid(object value)
        {
            if (string.IsNullOrEmpty(Pattern))
                return false;

            Regex reg;
            try
            {
                reg = new Regex(Pattern);
            }
            catch
            {
                return false;
            }

            if (value == null)
                return false;

            return reg.IsMatch(value.ToString());
        }
    }
}
