﻿using System;

namespace ES.Infrastructure35.ComponentModel_.DataAnnotations_
{
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = true, Inherited = false)]
    public abstract class CustomValidationBaseAttribute : Attribute
    {
        private object m_Model = null;
        protected object Model { get { return m_Model; } }

        private string m_ErrorMessage = null;
        public string ErrorMessage
        {
            get { return m_ErrorMessage; }
            set { m_ErrorMessage = value; }
        }

        public bool IsValid(object model, object value)
        {
            if (model == null)
                return false;

            m_Model = model;
            return IsValid(value);
        }

        public virtual string FormatErrorMessage(string displayName)
        {
            return string.Format(ErrorMessage, displayName);
        }

        protected abstract bool IsValid(object value);
    }
}
