﻿using System;
using System.Web.Mvc;
using ES.WebInfrastructure35.EasyUI.Builder;

namespace ES.Mvc40.EasyUI
{
    public class EasyUIForm : IDisposable
    {
        private readonly ViewContext m_viewContext = null;
        private bool m_disposed;
        private FormBuilder m_builder = null;

        static EasyUIForm()
        {
            ValidationAttributeBuilderFactory.InitializeBuilder(new MvcValidationAttributeBuilder());
        }

        public EasyUIForm(ViewContext viewContext, FormBuilder builder)
        {
            if (viewContext == null)
            {
                throw new ArgumentNullException("viewContext");
            }
            m_viewContext = viewContext;
            m_viewContext.FormContext = new FormContext();
            m_builder = builder;
        }

        public void Dispose()
        {
            this.Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (!this.m_disposed)
            {
                this.m_disposed = true;
                m_viewContext.Writer.Write(m_builder.CreateEndHtml());
                m_viewContext.FormContext = null;
            }
        }
        public void EndForm()
        {
            this.Dispose(true);
        }
    }
}
