﻿using System.Collections.Generic;
using ES.WebInfrastructure35.Web_;

namespace ES.WebInfrastructure35.EasyUI.Builder
{
    internal class BuilderBase
    {
        private string m_tag = null;
        private string m_control = null;
        private IDictionary<string, string> m_attributes = null;

        public BuilderBase(string tag, string attributeJson) : this(tag, null, attributeJson) { }

        public BuilderBase(string tag, string control, string attributeJson)
        {
            m_tag = tag;
            m_control = control;
            if (!string.IsNullOrEmpty(attributeJson))
                m_attributes = JsonHelper.Deserialize<IDictionary<string, string>>(attributeJson);
        }

        public override string ToString()
        {
            TagBuilder builder = new TagBuilder(m_tag, m_attributes);

            if (!string.IsNullOrEmpty(m_control))
                builder.AddAttribute("class", "easyui-{0}", m_control);

            ExpandFor(builder);
            return builder.ToString();
        }

        protected virtual void ExpandFor(TagBuilder builder) { }

        public static implicit operator string(BuilderBase builder)
        {
            return builder.ToString();
        }
    }
}
