﻿using System;
using System.Linq.Expressions;
using ES.Infrastructure35.DateTime_;
using ES.WebInfrastructure35.Web_;

namespace ES.WebInfrastructure35.EasyUI.Builder
{
    internal class DateboxBuilder<TModel> : ParseExpressionBuilder<TModel>
    {
        public DateboxBuilder(Expression<Func<TModel, object>> expression, TModel model, string attributeJson)
            : base("input", "datebox", expression, model, attributeJson) { }

        protected override void AppendValue(ref TagBuilder builder, object value)
        {
            if (value != null)
            {
                try
                {
                    var date = Convert.ToDateTime(value);
                    builder.AddAttribute("value", DateTimeFormatterFactory.Formatter.ToCustomDateString(date));
                }
                catch { }
            }
        }
    }
}
