﻿using System.Text;

namespace ES.WebInfrastructure35.EasyUI.Builder
{
    public class FormBuilder
    {
        private string m_selector = "form";

        public string CreateBeginHtml(string action)
        {
            return CreateBeginHtml(action, string.Empty, string.Empty);
        }

        public string CreateBeginHtml(string action, string id)
        {
            return CreateBeginHtml(action, id, string.Empty);
        }

        public string CreateBeginHtml(string action, string id, string method)
        {
            StringBuilder builder = new StringBuilder("<form");

            if (!string.IsNullOrEmpty(id))
            {
                builder.AppendFormat(" id=\"{0}\"", id);
                m_selector = string.Format("#{0}", id);
            }

            builder.AppendFormat(" action=\"{0}\" method=\"{1}\">", action, string.IsNullOrEmpty(method) ? "post" : method);
            return builder.ToString();
        }

        public string CreateEndHtml()
        {
            return "</form>";
        }
    }
}
