﻿using System;
using System.Linq.Expressions;
using ES.Infrastructure35.String_;
using ES.WebInfrastructure35.Web_;

namespace ES.WebInfrastructure35.EasyUI.Builder
{
    internal class NumberboxBuilder<TModel> : ParseExpressionBuilder<TModel>
    {
        public NumberboxBuilder(Expression<Func<TModel, object>> expression, TModel model, string attributeJson)
            : base("input", "numberbox", expression, model, attributeJson) { }

        protected override void AppendValue(ref TagBuilder builder, object value)
        {
            if (value != null)
            {
                string numStr = value.ToString();
                if (numStr.IsPrueNumber())
                    builder.AddAttribute("value", numStr);
            }
        }
    }
}
