﻿using System;
using System.Linq.Expressions;
using ES.WebInfrastructure35.Web_;

namespace ES.WebInfrastructure35.EasyUI.Builder
{
    internal class ValidateboxBuilder<TModel> : ParseExpressionBuilder<TModel>
    {
        private string m_type = null;

        public ValidateboxBuilder(Expression<Func<TModel, object>> expression, TModel model, string type, string attributeJson)
            : base("input", "validatebox", expression, model, attributeJson)
        {
            if (string.IsNullOrEmpty(type))
                throw new ArgumentNullException("type不能为空!");

            m_type = type;
        }

        protected override void ExpandFor(TagBuilder builder)
        {
            base.ExpandFor(builder);
            builder.AddAttribute("type", m_type);
        }
    }
}
